{Graphics functions}
{ Created in 1999-03-16 - Copyright (C) Joel Yliluoma }

{$O+}
Unit GR4JKA;

Interface

Uses Crt;

{ Tmn kirjastotiedoston Naamojenvlinen osuus:

  640x480x16 - tilan aliohjelmat:
  Procedure Bar12(x1, y1, x2, y2: Integer; Vri: Byte);
  Procedure Circle12(x, y, Sde: Integer; Vri: Byte);
  Procedure Cls12;
  Procedure FillDisk12(x, y, Sde: Integer; Vri: Byte);
  Procedure HorLine12(x, y1, y2: Word; Vri: Byte);
  Procedure Line12(x1, y1, x2, y2: Integer; Vri: Byte);
  Procedure Pset12(x, y: Integer; Vri: Byte);

  Function Point12(x, y: Integer): Byte;

  Procedure RectAngle12(x1, y1, x2, y2: Integer; Vri: Byte);

}

Procedure Screen12;
Procedure Pset12(x, y: Integer; PColor: Byte);
Function Point12(x, y: Integer): Byte;
Procedure Line12(x1,y1,x2,y2:Integer;Color:Byte);
Procedure Circle12(x, y, Sade: Integer; Color: Byte);
Procedure FillDisk12(x, y, Sade: Integer; Color: Byte);
Procedure RectAngle12(x1,y1,x2,y2: Integer; c: Byte);
Procedure HorLine12(x1, x2, y: Word; c: Byte);
Procedure VerLine12(x, y1, y2: Word; c: Byte);
Procedure Bar12(x1,y1,x2,y2:Integer;c:Byte);
Procedure Cls12(Color: Byte);

{---------------------------------------------------------------------------}
{CRT-functions' replacements}
Procedure GotoXYProc(x, y: Integer);
Procedure WindowProc(x1,y1,x2,y2: Integer);
Procedure ClrScrProc;
Function WhereXFunc: Integer;
Function WhereYFunc: Integer;
Procedure WriteStr(Size:Word; Str: PChar);
{---------------------------------------------------------------------------}

Type
  Directions = (Up,Down,Left,Right);

Const
  TextBack: Byte = 0;
  FontLev: Byte = 8;
  TextDir: Directions = Right;
Var
  SVGAIncXRes: Word;
  SVGAIncYRes: Word;
  FontKork: Byte;

Implementation

Var
  CursX, CursY: Byte;
  Font8, Font14, Font16: Pointer;

Procedure Screen12; Assembler;
Asm
  mov ax, 12h
  int 10h
  mov GraphMode, True
End;

Procedure Pset12; Assembler;
Asm
  {$IFOPT R+}
  mov ax, x; or ax, ax; js @Pois; cmp ax, 639; jg @Pois
  mov ax, y; or ax, ax; js @Pois; cmp ax, 479; jg @Pois
  {$ENDIF}
  mov ax, y
  shl ax, 4
  mov bx, ax
  shl ax, 2
  add ax, bx

  mov bx, x
  mov cl, bl

  shr bx, 3
  add bx, ax

  and cl, 7
  xor cl, 7

  mov dx, 3CEh
  mov ax, 0108h
  shl ah, cl
  out dx, ax

  mov ax, 0205h
  out dx, ax

  mov es, SegA000

  mov al, es:[bx]
  mov al, PColor
  mov es:[bx], al

  mov ax, 0FF08h
  out dx, ax

  mov ax, 5
  out dx, ax
  jmp @R
@Pois:
  mov ax, 201
  jmp HaltError
@R:
End;

Function Point12; Assembler;
Asm
  {$IFOPT R+}
  mov ax, x; or ax, ax; js @G2; cmp ax, 639; jg @G2
  mov ax, y; or ax, ax; js @G2; cmp ax, 479; jg @G2
  {$ENDIF}
  mov ax,y
  mov dx,80
  mul dx
  mov si,x
  mov cx,si
  shr si,3
  add si,ax
  and cl,7
  xor cl,7
  mov ch,1
  shl ch,cl
  mov es,SegA000
  mov dx,3CEh
  mov ax,0304h
  xor bl,bl
@G1:out dx,ax
  mov bh,es:[si]
  and bh,ch
  neg bh
  rol bx,1
  dec ah
  jge @G1
  mov al,bl
  jmp @R
@G2:
  mov ax, 201
  jmp HaltError
@R:
End;

Procedure Line12;
Var i, DeltaX, DeltaY, NumPixels,
  d, dinc1, dinc2,
  x, xinc1, xinc2,
  y, yinc1, yinc2: Integer;
begin
  { Calculate DeltaX and DeltaY for initialisation }
  DeltaX := abs(x2 - x1);
  DeltaY := abs(y2 - y1);

  { Initialize all vars based on which is the independent variable }
  if DeltaX >= DeltaY then
  begin
    { x is independent variable }
    NumPixels := DeltaX + 1;
    d := DeltaY Shl 1 - DeltaX;
    dinc1 := DeltaY Shl 1;
    dinc2 := (DeltaY - DeltaX) shl 1;
    xinc1 := 1; yinc1 := 0;
    xinc2 := 1; yinc2 := 1
  end
  else
  begin
    { y is independent variable }
    NumPixels := DeltaY + 1;
    d := DeltaX Shl 1 - DeltaY;
    dinc1 := DeltaX Shl 1;
    dinc2 := (DeltaX - DeltaY) shl 1;
    xinc1 := 0; yinc1 := 1;
    xinc2 := 1; yinc2 := 1
  end;

  { Make sure x and y move in the right directions }
  If x1 > x2 Then Begin xinc1 := -xinc1; xinc2 := -xinc2 End;
  If y1 > y2 Then Begin yinc1 := -yinc1; yinc2 := -yinc2 End;

  { Start drawing at <x1, y1> }
  x := x1; y := y1;

  { Draw the pixels }
  For i := 1 To NumPixels Do
  Begin
    PSet12(x, y, Color);
    If d < 0 Then
    Begin
      Inc(d, dinc1);
      Inc(x, xinc1);
      Inc(y, yinc1)
    End
    Else
    Begin
      Inc(d, dinc2);
      Inc(x, xinc2);
      Inc(y, yinc2)
    End
  End
End;

Procedure Circle12;
Var Yi, XRad: Integer;
Begin
  For Yi := 0 To Sade Do
  Begin
    XRad := Round(Sade*Sade-Yi*Yi);
    Pset12(x-XRad,y+Yi,Color);
    Pset12(x+XRad,y+Yi,Color);
    Pset12(x+Yi,y-XRad,Color);
    Pset12(x+Yi,y+XRad,Color);

    Pset12(x+XRad,y-Yi,Color);
    Pset12(x-XRad,y-Yi,Color);
    Pset12(x-Yi,y-XRad,Color);
    Pset12(x-Yi,y+XRad,Color)
  End
End;

Procedure FillDisk12;
Var Xi, Yi, XRad: Integer;
Begin
  For Yi := 0 To Sade Do
  Begin
    XRad := Round(Sqrt(Sade*Sade-Yi*Yi));
    For Xi := 0 To XRad Do
    Begin
      Pset12(x+Xi,y+Yi,Color);
      Pset12(x-Xi,y+Yi,Color);
      Pset12(x+Xi,y-Yi,Color);
      Pset12(x-Xi,y-Yi,Color)
    End
  End
End;

Procedure RectAngle12;
Begin
  Line12(x1,y1,x2,y1,c); Line12(x1,y2,x2,y2,c);
  Line12(x1,y1,x1,y2,c); Line12(x2,y1,x2,y2,c)
End;

Procedure HorLine12; Assembler;
Asm
  mov ax, x1; mov bx, x2; cmp ax, bx; jb @P2; xchg ax, bx
@P2:push ax; push bx
  push ax; push y; push word ptr c; call PSet12
  pop bx; pop ax; inc ax; cmp ax, bx; jbe @P2
End;

Procedure VerLine12; Assembler;
Asm
  mov ax, y1; mov bx, y2; cmp ax, bx; jb @P2; xchg ax, bx
@P2:push ax; push bx
  push x; push ax; push word ptr c; call PSet12
  pop bx; pop ax; inc ax; cmp ax, bx; jbe @P2
End;


Procedure Bar12;
Var y: Integer;
Begin
  For y := y1 To y2 Do HorLine12(x1,x2,y,c)
End;

Procedure Cls12; Assembler;
Asm
  mov ah, 6
	mov al, 0
	xor cx, cx
	mov dx, $5F4F
	mov bh, Color
	int 10h {BIOS is very useful when I don't have enough abilities}
End;

Procedure WriteStr;
Var a: Byte; x, y: Word;
Label Feed;
Begin
  If(Mem[$40:$49] < $14)And Not GraphMode Then
    CrtOldWrite(Size, Str)
  Else
  Begin
    While Size>0 Do
    Begin
      Case Str^ Of
        #8: If WhereX>1 Then GotoXY(WhereX-1, WhereY);
        #7: Begin
              Port[$61] := Port[$61]Or 3; Delay(100);
              Port[$61] := Port[$61]And $FC
            End;
        #13: GotoXY(1, WhereY);
        #10:
Feed:     If WhereY > Hi(WindMax) Then
          Begin
            If Not ModeX Then
            Begin
              Asm mov al, TextAttr; push ax End;
              TextAttr := TextBack;
              CrtOldWrite(1, Str);
              Asm pop ax; mov TextAttr, al End
            End
            Else
            Begin
              For a := 0 To 3 Do
              Begin
                PortW[$3CE] := $0400+a;
                PortW[$3C4] := $0200+(1 Shl a);
                For y := Hi(WindMin) To Hi(WindMax)Do
                  Move(Mem[SegA000:Lo(WindMin)*4+1],
                       Mem[SegA000:Lo(WindMin)*4], (Lo(WindMax)-Lo(WindMin)+1)*4)
              End;
              PortW[$3C4] := $0F02
            End
          End
          Else GotoXY(WhereX, WhereY+1)
      Else
        {$IFOPT R+}{$DEFINE RPlus}{$R-}{$ENDIF}
        Case FontKork Of
          8:For y := 0 To 7 Do
              For x := 0 To FontLev-1 Do
                PSet12(Word(CursX+Lo(WindMin)-1)*FontLev+x, Word(CursY+Hi(WindMin)-1)Shl 3+y,
                  TextBack+Integer(Integer(TextAttr)-Integer(TextBack))*
                    (Mem[Seg(Font8^):Ofs(Font8^)+Word(Str^)Shl 3+y]Shr(7-x*8 Div FontLev)And 1));
          14:For y := 0 To 13 Do
              For x := 0 To FontLev-1 Do
                PSet12(Word(CursX+Lo(WindMin)-1)*FontLev+x, Word(CursY+Hi(WindMin)-1)*14+y,
                  TextBack+(TextAttr-TextBack)*
                    (Mem[Seg(Font14^):Ofs(Font14^)+Word(Str^)*14+y]Shr(7-x*8 Div FontLev)And 1));
          16:For y := 0 To 15 Do
              For x := 0 To FontLev-1 Do
                PSet12(Word(CursX+Lo(WindMin)-1)*FontLev+x, Word(CursY+Hi(WindMin)-1)Shl 4+y,
                  TextBack+Integer(Integer(TextAttr)-Integer(TextBack))*
                    (Mem[Seg(Font16^):Ofs(Font16^)+Word(Str^)Shl 4+y]Shr(7-x*8 Div FontLev)And 1));
          32:For y := 0 To 15 Do
              For x := 0 To FontLev-1 Do
              Begin
                PSet12(Word(CursX+Lo(WindMin)-1)*FontLev+x, Word(CursY+Hi(WindMin)-1)*32+y*2,
                  TextBack+Integer(Integer(TextAttr)-Integer(TextBack))*
                    (Mem[Seg(Font16^):Ofs(Font16^)+Word(Str^)Shl 4+y]Shr(7-x*8 Div FontLev)And 1));
                PSet12(Word(CursX+Lo(WindMin)-1)*FontLev+x, Word(CursY+Hi(WindMin)-1)*32+y*2+1,
                  TextBack+Integer(Integer(TextAttr)-Integer(TextBack))*
                    (Mem[Seg(Font16^):Ofs(Font16^)+Word(Str^)Shl 4+y]Shr(7-x*8 Div FontLev)And 1))
              End;
        End;
        {$IFDEF RPlus}{$UNDEF RPlus}{$R+}{$ENDIF}
        Inc(CursX);
        If CursX > Lo(WindMax)-Lo(WindMin)+1Then
        Begin
          GotoXY(1, WhereY);
          Goto Feed
        End
      End;
      Dec(Size);
      Inc(Str)
    End
  End;
End;

Procedure GotoXYProc;
Begin
  CrtOldGotoXY(x, y);
  CursX := x; CursY := y
End;

Procedure ClrScrProc;
Const Space: Char = ' ';
Var x: Word;
Begin
  If GraphMode Then
  Begin
    CursX := 1;
    CursY := 1;

    For x := 1 To (Hi(WindMax)-Hi(WindMin)+1)*(Lo(WindMax)-Lo(WindMin)+1)Do
      WriteStr(1, @Space);
    CursX := 1; CursY := 1
  End
  Else
    CrtOldClrScr
End;

Procedure WindowProc;
Begin
  If GraphMode Then
  Begin
    WindMin := (x1-1)+(y1-1)Shl 8;
    WindMax := (x2-1)+(y2-1)Shl 8;
    CursX := 1; CursY := 1
  End
  Else
    CrtOldWindow(x1,y1,x2,y2)
End;

Function WhereXFunc;
Begin
  If Not GraphMode
    Then WhereXFunc := CrtOldWhereX
    Else WhereXFunc := CursX
End;

Function WhereYFunc;
Begin
  If Not GraphMode
    Then WhereYFunc := CrtOldWhereY
    Else WhereYFunc := CursY
End;

Begin
  With CRTLocal Do
  Begin
    WriteStrProcAddr := WriteStr;
    GotoXYProcAddr := GotoXYProc;
    WhereXFuncAddr := WhereXFunc;
    WhereYFuncAddr := WhereYFunc;
    ClrScrProcAddr := ClrScrProc;
    WindowProcAddr := WindowProc
  End;
  DirectVideo := False;
  Asm
    push bp
     mov ax, 1130h
     mov bh, 6
     int 10h
     mov Font16.word[0], bp
     mov Font16.word[2], es
     mov ax, 1130h
     mov bh, 2
     int 10h
     mov Font14.word[0], bp
     mov Font14.word[2], es
     mov ax, 1130h
     mov bh, 3
     int 10h
     mov Font8.word[0], bp
     mov Font8.word[2], es
    pop bp
  End
End.