{$O-}
{
  This unit contains the non-overlaible play routines
}

{ Created in <=2000 - Copyright (C) Joel Yliluoma }

Unit NESMusa2;

Interface

Function GetEnvVar(N: PChar): PChar; {Non-overlaid version!}
Function StrnICmp(Str1, Str2: PChar; MaxLen: Word): Integer; {also}

Procedure _WriteDSP;
Procedure _BitDelay;
Function  _InitDSP: Boolean;
Procedure _DoneDSP;

(*Procedure Show1;*)
Procedure Show3;
Procedure Show5;

Implementation

Uses WinDos, Strings, Crt, {Mouse, }SVGA, NesMusa1, DosMem;

Function GetEnvVar(N: PChar): PChar;
Var
  L: Word;
  P: PChar;
Begin
  For L:=0To 255Do
    If N[L]=#0 Then Break;
  P:=Ptr(Word(Ptr(PrefixSeg,44)^),0);
  While P^<>#0 Do
  Begin
    If(StrNICmp(P,N,L)=0)And(P[L]='=')Then
    Begin
      GetEnvVar:=P+L+1;
      Exit
    End;
    While P^<>#0 Do Inc(P);
    Inc(P)
  End;
  GetEnvVar:=Nil
End;

Function StrnICmp(Str1, Str2: PChar; MaxLen: Word): Integer; assembler;
Asm
        PUSH    DS
        CLD
        LES     DI,Str2
        MOV     SI,DI
        MOV     AX,MaxLen
        MOV     CX,AX
        JCXZ    @@4
        XCHG    AX,BX
        XOR     AX,AX
        CWD
        REPNE   SCASB
        SUB     BX,CX
        MOV     CX,BX
        MOV     DI,SI
        LDS     SI,Str1
@@1:    REPE    CMPSB
        JE      @@4
        MOV     AL,DS:[SI-1]
        CMP     AL,'a'
        JB      @@2
        CMP     AL,'z'
        JA      @@2
        SUB     AL,20H
@@2:    MOV     DL,ES:[DI-1]
        CMP     DL,'a'
        JB      @@3
        CMP     DL,'z'
        JA      @@3
        SUB     DL,20H
@@3:    SUB     AX,DX
        JE      @@1
@@4:    POP     DS
End;

Procedure _WriteDSP; Assembler;
Asm
 push dx
  push ax
   mov dx, BasePort
   add dx, 00Ch
@1: in al, dx
   or al, al
   js @1
  pop ax
  out dx, al
 pop dx
End;
Function _ReadDSP: Byte; Assembler;
Asm
  push dx
   mov dx, BasePort
   add dx, 00Eh
@1:in al, dx
   or al, al
   jns @1
   mov dx, BasePort
   add dx, 00Ah
   in al, dx
  pop dx
End;
Procedure _WriteDAC; Assembler;
Asm
  push ax
   mov al, 10h
   call _WriteDSP
  pop ax
  call _WriteDSP
End;
Procedure _BitDelay; Assembler; Asm push cx;xor cx,cx;@1:loop @1;pop cx End;
Function _InitDSP: Boolean; Assembler;
Asm
  push dx
   mov dx, BasePort
   add dl, 6
   mov al, 1
   out dx, al
   call _BitDelay
   dec ax
   out dx, al
   call _BitDelay
   add dl, 8
   in al, dx
   and al, 80h
   jz @1
   sub dl, 4
   in al, dx
   cmp al, 0AAh
   je @2
   xor ax, ax
   jmp @1
@2:mov al, 0D1h
   call _WriteDSP
   mov al, 1
@1:
  pop dx
End;
Procedure _DoneDSP; Assembler; Asm mov al,0D3h;call _WriteDSP;call _WriteDSP End;

Var
  TicLen: Word;
  SampleSize: Word;
  OldI0D: Procedure;
  OldI08: Procedure;
  SmpBuf, Cache: PChar;
Var
  oBuf,
  s1,s2,s3: PChar;
  Pitch: Word;
  TimeConst: Byte;
  TicCount: Word;
Var
  Rivi: Word;
  No_EOI: Boolean;
  IRQCounter: Word;
  IRQProblem: Boolean;
  SBuf: Array[0..399]Of Word;
  Volume: Array[0..3]Of Byte;
  Herz, Pos: Array[0..4]Of LongInt;
Const
  PlayChan: Array[0..3]Of Boolean = (True,True,True,True);
Var
  UusPala: Boolean;

Procedure NewI0D; Interrupt; Forward;
Procedure Palanen(Dest: PChar); Forward;
Procedure NewI08(Fl,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word); Interrupt; Forward;

Procedure Palanen(Dest: PChar);
Var
  p: PChar;
  l: Integer;
  k: Word;
  j: Byte;
Begin
  p := Dest;
  For l := 0 To TicCount-1 Do
  Begin
    For j := 0 To 3 Do
    Begin
      Volume[j] := Hi(Word(Laulu^[Rivi][j].Volume) * GlobalVolume);
      If Laulu^[Rivi][j].Note < 254 Then
      Begin
        Herz[j] := Period[Laulu^[Rivi][j].Note And 15] * (1 Shl (Laulu^[Rivi][j].Note Shr 4));
        If j > 1
          Then Herz[j] := Herz[j] * 8 Div 9
          Else Herz[j] := Herz[j] * 4 Div 9
      End
    End;

    For k := TicLen-1 DownTo 0 Do
      Asm
        xor cx, cx
        mov di, 3
@@1:    mov bx, di
        cmp byte ptr PlayChan[bx], 0
        je @@6
        mov al, byte ptr Volume[di]; {cbw; }or al, al; jz @@6
        shl bx, 2
        db 66h; mov ax, word ptr Herz[bx]
        db 66h; add word ptr Pos[bx], ax
        mov ax, word ptr Pos[bx+1]
        cmp di, 3; je @@2
        shr ax, 6
        cmp di, 2; jne @@3
        les si, s2
        jmp @@4
@@2:    les si, s3
        shr ax, 7
        and ax, 8191
        jmp @@5
@@3:    les si, s1
        and ax, 31
@@4:    and ax, 127
@@5:    add si, ax
        mov al, es:[si]
        mul byte ptr Volume[di]
        add cx, ax
@@6:    dec di
        jns @@1
        les di, p
        mov byte ptr es:[di], ch
        inc word ptr p
      End;

    If(@Player = @Show3)Or(@Player = @Show5)Then
    Begin
      If TakaPerin Then
      Begin
        Dec(Rivi);
        If Rivi < Looppaa Then Rivi := Riveja-1
      End
      Else
      Begin
        Inc(Rivi);
        If Rivi >= Riveja Then Rivi := Looppaa
      End
    End
  End;
End;

Procedure Nukku(Text: PChar);
Var
  x, y: Integer;
  XSize, y2: Word;
  TLen, w, i: Word;
Begin
  TLen := strlen(Text);

  XSize := MemW[Seg0040:$4A];
  y2 := (Mem[Seg0040:$84]+1)Div 2;

  w := 0;
  For y := -2 To 2 Do
    For x := XSize Div 2 - TLen Div 2 - 2 To
             XSize Div 2 + TLen Div 2 + 2 Do
    Begin
      i := ((y2+y)*XSize+x)*2;
      SBuf[w] := MemW[SegB800:i];
      MemW[SegB800:i] := $4F00+Ord('#');
      Inc(w)
    End;

  For y := -1 To 1 Do
    For x := XSize Div 2 - TLen Div 2 - 1 To
             XSize Div 2 + TLen Div 2 + 1 Do
      MemW[SegB800:((y2+y)*XSize + x)*2] := $4E20;

  For x := 0 To TLen-1 Do
    Mem[SegB800:(y2*XSize + x + (XSize-TLen)Div 2)*2] := Ord(Text[x]);

  Delay(500);

	w := 0;
  For y := -2 To 2 Do
    For x := XSize Div 2 - TLen Div 2 - 2 To
             XSize Div 2 + TLen Div 2 + 2 Do
    Begin
      i := ((y2+y)*XSize+x)*2;
      MemW[SegB800:i] := SBuf[w];
      Inc(w)
    End
End;

Procedure NewI08(Fl,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
Begin
  If(DI=$4123)And(SI=$1234)Then DI := AX;

  If IRQCounter < 999 Then Inc(IRQCounter);
  If IRQProblem Then
    If(IRQCounter < 999)And(IRQCounter > 127)Then
    Begin
      Nukku('Too bad.');
      IRQCounter := 999
    End;

  If(IRQCounter = 91)Or(IRQCounter > 140)Then {5 sekuntia ilman nt? Apua...}
  Begin
    IRQProblem := True;
    If IRQCounter < 999 Then Nukku('Soundcard is sleeping? No way!');
    If(IRQCounter < 999)Or((Mem[Seg0040:$6C]And 15)=0)Then
    Begin
			_InitDSP;
      Asm
        mov No_EOI, 1
        mov al, IRQ
        add al, 8
        mov byte ptr cs:[offset @@1], al
        db 0CDh
    @@1:db 0
				mov No_EOI, 0
			End
		End
	End;
	InLine($9C); OldI08
End;

Procedure NewI0D;
Const DMAxA: Array[0..3]Of Byte = (0,2,4,6);
Const DMAxL: Array[0..3]Of Byte = (1,3,5,7);
Const DMAxP: Array[0..3]Of Byte = ($87,$83,$81,$82);
Begin
	Asm
		mov dx, BasePort
		add dx, 00Eh
		in al, dx
		sub dx, 4
		in al, dx
	End;

	If Not No_EOI Then
	Begin
		IRQCounter := 0;
		IRQProblem := False
	End;

	TimeConst := 256 - 1000000 Div Pitch;

	UusPala := True;
	Move(Cache^, SmpBuf^, SampleSize);

	Asm
		mov bx, word ptr SmpBuf[2]
		mov dx, bx
		shl bx, 4
		shr dx, 12
		add bx, word ptr SmpBuf[0]
		adc dx, 0
		mov ah, dl

		mov al,  4; add al,DMA; out 0Ah, al
		mov al,  0;             out 0Ch, al
		mov al,$48; add al,DMA; out 0Bh, al

		xor dh, dh
		mov dl, DMA
		mov si, dx
		mov dl, byte ptr DMAxA[si]

		mov al, bl; out dx, al
		mov al, bh; out dx, al

		mov dl, byte ptr DMAxP[si]
		mov al, ah; out dx, al

		mov dl, byte ptr DMAxL[si]

		mov cx, SampleSize
		{dec cx}
		mov al, cl; out dx, al
		mov al, ch; out dx, al

		mov ax, si; out 0Ah, al

		mov al, 40h; call _WriteDSP
		mov al, TimeConst; call _WriteDSP

		mov al, 14h; call _WriteDSP

		mov al, SampleSize.byte[0]; call _WriteDSP
    mov al, SampleSize.byte[1]; call _WriteDSP
  End;

  Palanen(Cache);

  Port[$21] := Port[$21]And Not (1 Shl IRQ);
  If Not No_EOI Then
  Begin
		Port[$20] := $20;
		Port[$A0] := $20
  End
End;

Var
  IRQs: Boolean;

Procedure Show3Init;
Var
  i: Word;
Label P2;
Begin
  Asm
    mov di, 4123h
    push di
     push di
     call RandInt
    pop di
    mov si, 1234h
    int 8
    cmp di, ax
    jne P2
  End;
  Error('Already playing something!');
P2:
  Debug('Initializing DSP');

  IRQs := True;
	GetIntVec(8, @OldI08);
  GetIntVec(IRQ+8, @OldI0D);

	If Not _InitDSP Then
	Begin
    Write('Sound Blaster not found on port 2', HC[(BasePort Shr 4)And 15]);
    Error('0h!')
  End;
  No_EOI := False;
	SetIntVec(IRQ+8, @NewI0D);

  AllocMem('DMA buffer', oBuf, $1000 + (BufSize+15)Shr 4);
  SmpBuf := Ptr((Seg(oBuf^)+$FFF)And $F000, 0);

  TicLen := Rate Div TicPeriod;
  TicCount := (BufSize Div TicLen);
	SampleSize := TicCount * TicLen;

	ReSize(oBuf, Seg(SmpBuf^) - Seg(oBuf^) + (SampleSize+15)Shr 4);
  If DosMemDebug Then Debug('Splitting DMA buffer into two parts (style "don''t try this yourself")');
  Mem [Seg(SmpBuf^)-1:0]  :=  Mem[Seg(oBuf^)-1: 0];
  MemW[Seg(SmpBuf^)-1:1]  := MemW[Seg(oBuf^)-1: 1];
  MemW[Seg(SmpBuf^)-1:3]  := (SampleSize+15)Shr 4;
  MemL[Seg(SmpBuf^)-1:5]  := MemL[Seg(oBuf^)-1: 5];
  MemL[Seg(SmpBuf^)-1:9]  := MemL[Seg(oBuf^)-1: 9];
  MemL[Seg(SmpBuf^)-1:12] := MemL[Seg(oBuf^)-1:12];
  MemW[Seg(oBuf^)-1:3] := Seg(SmpBuf^) - Seg(oBuf^)-1;

	If DosMemDebug Then Debug('Freeing the first one (same style, touching MCB directly)');
  MemW[Seg(oBuf^)-1:1] := 0;
  If Debugging And DosMemDebug Then
  Begin
    Write('This nice trick gave us ');
    Size(LongInt(Seg(SmpBuf^) - Seg(oBuf^)-1)Shl 4);
    Write(' of free memory.'^M^J'DMA buffer is now a ');
    Size(SampleSize);
    Write(' long continous block at ',HC[Hi(Seg(SmpBuf^))Shr 4]);
    Debug('000:0000.');
  End;

  For i := 0 To High(MemBlocks.Dat)Do
    If MemBlocks.Dat[i].Seg = Seg(oBuf^)Then MemBlocks.Dat[i].Seg := Seg(SmpBuf^);

  AllocMem('cache buffer', Cache, (SampleSize+15)Shr 4);
  s1 := PChar(@NSMP1)+$50;
  s2 := PChar(@NSMP2)+$50;
  s3 := PChar(@NSMP3)+$50;

	FillChar(SmpBuf^, SampleSize, 0);
	FillChar(Cache^, SampleSize, 0);

	Palanen(SmpBuf);
	Asm mov al, 0D0h; call _WriteDSP End;

	Pitch := Rate;
	If TakaPerin
		Then Rivi := Riveja-1
		Else Rivi := 0;

	Asm
		pushf
		push cs
		call near ptr NewI0D
	End;
	SetIntVec(8, @NewI08)
End;

Procedure Show3Done;
Begin
  If Not IRQs Then Exit;
  SetIntVec(IRQ+8, @OldI0D);
	SetIntVec(8, @OldI08);
  UnAllocMem(SmpBuf);
  UnAllocMem(Cache);
  IRQs := False;
  _DoneDSP
End;

Procedure Show3;
Begin
  Show3Init;

  WriteLn(FreeMem, ' bytes memory');
  Exec(strpas(GetEnvVar('COMSPEC')), '');

  Show3Done
End;

(*
Type
  PDotti = ^TDotti;
  TDotti = Array[0..10, 0..9]Of Char;
Const
  Dot1 =
    '          '+
    '          '+
    '          '+
    '    ###x  '+
    '  x#####x '+
    ' #######x '+
    ' x######  '+
    '  x###    '+
    '          '+
    '          '+
    '          ';
  Dot2 =
    '          '+
    '          '+
		'          '+
    '   x###x  '+
    '  x#   #x '+
    ' x#    #x '+
    ' x#   #x  '+
    '  x###x   '+
    '          '+
    '          '+
    '          ';
  Drum =
    '          '+
    'x       x '+
    ' #x   x#  '+
    '  x#x#x   '+
    '   x#x    '+
    '  x#x#x   '+
    ' #x   x#  '+
    'x       x '+
    '          '+
    '          '+
    '          ';
  Down: TDotti =
   ('#         ',
    '#         ',
    '#         ',
    '#         ',
    '#x##x     ',
    '## x#     ',
    '#  x#     ',
    '#  x#     ',
    '#  x#     ',
    '# x#      ',
    '###x      ');
  Tauko1 =
    ' ####x    '+
    '    x#    '+
    '     x#   '+
    '    ##    '+
    '   #xxx   '+
    '   ####   '+
    '   #xxx   '+
    '   x#     '+
    '   x#     '+
    '  x#      '+
    '###       ';
	Tauko2 =
    '          '+
    '          '+
    ' #########'+
    ' #########'+
    ' #########'+
    '          '+
    '          '+
    '          '+
    '          '+
    '          '+
    '          ';
  Tauko4 =
    '          '+
    '          '+
    '          '+
    '          '+
    '          '+
    '          '+
    ' #########'+
    ' #########'+
    ' #########'+
    '          '+
    '          ';


Procedure Show1;
Var
  EkaRivi: Word;
  Rows: Integer;
  Endi: Integer;
Const
  ViivaPax = 8;
  Res = 5;
  Const
    Back = 0;
    Viiva = 8;
    Dim = 7;
    Row1 = 50;

  Procedure Clr;
  Var i: Integer;
  Begin
    Cls12(Back);

		Rows := 0;
    EkaRivi := Row1;
    Repeat
      For i := 0 To 4 Do
        Line12(Res, EkaRivi+i*ViivaPax, Endi, EkaRivi+i*ViivaPax, Viiva);

      Line12(Res+0, EkaRivi, Res+0, EkaRivi+4*ViivaPax, Viiva);
      Line12(Res+1, EkaRivi, Res+1, EkaRivi+4*ViivaPax, Viiva);

      Inc(EkaRivi, 100);
      Inc(Rows)
    Until EkaRivi+ViivaPax*12 > 479;
    EkaRivi := Row1;
  End;

  Var
    tx, ty: Integer;

  Procedure Tapla(x: Integer; Const _Dot: String; Note, Oct: Integer; c1,c2: Byte; Keppi: Boolean);
  Const Lines: Array[0..11]Of Byte =
    (1,0, 1,0, 1, 1,0, 1,0, 1,0, 1); {c, c+,d ,d+,e ,f ,f+,g ,g+,a ,a+, b }
  Const AlinOct = 4;
  Var
    a, oy, dy: Integer; nx,ny: Byte;
    Ala, Ylla: Boolean;
    Dot: PDotti;
  Begin
    Dot := PDotti(PChar(@_Dot) + 1);

    a := Note + 12 * (Oct-AlinOct);
    dy := EkaRivi + ViivaPax*5 - 5;
    Ylla := a Div 12 > 0;
    While a <> 0 Do
      If a<0 Then
      Begin
        oy := dy;
        Inc(dy, Lines[(a+96)Mod 12]*ViivaPax Div 2);
        Ala := dy = oy;
        Inc(a)
      End
      Else
      Begin
        oy := dy;
        Dec(dy, Lines[(a+96)Mod 12]*ViivaPax Div 2);
        Ala := dy = oy;
				Dec(a)
      End;

    If Ala Then Dec(dy, ViivaPax Div 2);

    Begin
      oy := EkaRivi+ViivaPax*9 Div 2;
      While oy < dy+ViivaPax Div 2 Do
      Begin
        If _Dot = Drum
          Then Line12(x, oy+ViivaPax Div 2, x+ 9, oy+ViivaPax Div 2, Viiva)
          Else Line12(x, oy+ViivaPax Div 2, x+10, oy+ViivaPax Div 2, Viiva);
        Inc(oy, ViivaPax)
      End
    End;

    tx := x+9;
    ty := dy+7;
    For ny := 0 To 10 Do
      For nx := 0 To 9 Do
        Case Dot^[ny, nx]Of
          '#': PSet12(nx+x, dy+ny, c1);
          'x': PSet12(nx+x, dy+ny, c2);
        End;

    If Not Ala Then
      For ny := 0 To 10 Do
        For nx := 0 To 9 Do
          Case Down[ny, nx]Of
            '#': PSet12(nx+x-2, dy+ny-5, 8);
            'x': PSet12(nx+x-2, dy+ny-5, 8);
          End;

    If Keppi Then
      If _Dot = Drum Then
        If Ylla
          Then Line12(x+4, dy+5, x+4, dy+15,c1)
          Else Line12(x+4, dy+5, x+4, dy-5, c1)
      Else
      Begin
        If Ylla
          Then Line12(x+2, dy+5, x+2, dy+18,c1)
          Else Line12(x+8, dy+5, x+8, dy-8, c1);
      End
  End;
Var
  j: Word;
  Note, Oct, Volume: Byte;
  i: Float;
  x, y: Word;
  Tahti: Byte;
  Function Nuotti(Where: Float; Chan: Byte): Boolean;
  Var not1,not2, vol1,vol2: Byte;
  Begin
    Nuotti := False;
    If Where>=Riveja Then Where := Looppaa+(Where-Riveja);
    not1 := Laulu^[Round(Where)][Chan].Note;
    not2 := Laulu^[Round(Where)][Chan].Note;
    If not1 And 15 < 12 Then
      If Where<Spiid Then Nuotti := True
      Else
      Begin
        vol1 := Laulu^[Round(Where      )][Chan].Volume;
        If vol1 = 0 Then Exit;
        vol2 := Laulu^[Round(Where-Spiid)][Chan].Volume;
        If(vol1 > vol2)Or(not1 <> not2)Then Nuotti := True
      End
  End;
  Function Tyhjaa(Tahti: Integer; Where: Float; Chan: Byte): Integer;
  Var i: Integer;
  Begin
    i := 0;
    While Not Nuotti(Where, Chan)Do
    Begin
      Inc(i);
      If Tahti And 3 = 3 Then Break;
      Where := Where + Spiid;
      Inc(Tahti)
    End;
    Tyhjaa := i
  End;
Const
  Eka = Res+3;
  c1: Array[0..2]Of Byte = (15,14, 9);
  c2: Array[0..2]Of Byte = ( 7, 6, 1);
  Vari: Array[0..11]Of Byte = (15,14,12,12,12,4, 4,4,4,4,4,8);
Var
  PlayFlag: Word;
  Lopeta: Boolean;
  Nuotit: Array[0..9, 0..1]Of Float;
	Wait: Array[0..3]Of Byte;
  t1,t2,t3,t4: Integer;
Label P1;
Begin
  If Not(MouseInstalled Or MouseInstalled)Then Error('Mouse is missing!');

  AllocMem('sample 1', s1, 64 Shr 4);
  AllocMem('sample 2', s2, 64 Shr 4);
  AllocMem('sample 3', s3, 4096 Shr 4);
  For j := 0 To 4095 Do s3[j] := Chr(50 + Random(156));
  For j := 0 To 63 Do
  Begin
    s1[j] := Chr((j And 32)*50 Div 32);
    If j<32
      Then s2[j] := Chr(j*255 Div 31)
      Else s2[j] := Chr((63-j)*255 Div 31)
  End;

  Screen12;
  Endi := 639;

  TicLen := Rate Div TicPeriod;
P1:
  Clr;
  y := 0;
  i := 0;
  x := Eka;
  Tahti := 0;
  Lopeta := False;
  Repeat
    If Tahti=0 Then Nuotit[y][0] := i;
    If Tahti And 3 = 0 Then
    Begin
      FillChar(Wait, SizeOf(Wait), 0);
      Line12(x, EkaRivi+1, x, EkaRivi+ViivaPax*4-1, Viiva)
    End;

    {t4 := 999;}
    For j := 2 DownTo 0 Do
    Begin
      Wait[j] := 0;
      If Wait[j] > 0 Then Dec(Wait[j]);
      If Wait[j] = 0 Then
      Begin
        Note   := Laulu^[Round(i)][j].Note And 15;
				Oct    := Laulu^[Round(i)][j].Note Shr 4;
        Volume := Laulu^[Round(i)][j].Volume;
        t1 := Tyhjaa(Tahti, i, 0);
        t2 := Tyhjaa(Tahti, i, 1);
        t3 := Tyhjaa(Tahti, i, 2);
        Case Min(Min(t1,t2), t3)Of
          0:
          Begin
            t1 := Tyhjaa(Tahti, i+Spiid, 0);
            t2 := Tyhjaa(Tahti, i+Spiid, 1);
            t3 := Tyhjaa(Tahti, i+Spiid, 2);
            Case Min(t1, Min(t2,t3))Of
              0, 1:
              Begin
                If Nuotti(i, j)Then Tapla(x, Dot1, Note,Oct, c1[j], c2[j], True);
                Wait[j] := 1
              End;
              2:
              Begin
                If Nuotti(i, j)Then Tapla(x, Dot2, Note,Oct, c1[j], c2[j], True);
                Wait[j] := 2
              End;
              3:
              Begin
                If Nuotti(i, j)Then
                Begin
                  Tapla(x, Dot2, Note,Oct, c1[j], c2[j], True);
                  PSet12(tx+2,ty, c1[j])
                End;
                Wait[j] := 3
              End;
              4, 5:
              Begin
                If Nuotti(i, j)Then Tapla(x, Dot2, Note,Oct, c1[j], c2[j], False);
                Wait[j] := 4
              End;
              Else
                If Nuotti(i, j)Then
                Begin
                  Tapla(x, Dot2, Note,Oct, c1[j], c2[j], False);
                  PSet12(tx+2,ty, c1[j])
                End;
                Wait[j] := 6
            End;
          End;
					1:
          Begin
            Tapla(x, Tauko1, 10,4, c1[j], c2[j], False);
            Wait[j] := 1
          End;
          2, 3:
          Begin
            Tapla(x, Tauko2, 10,4, c1[j], c2[j], False);
            Wait[j] := 2
          End;
          Else
            Tapla(x, Tauko4, 10,4, c1[j], c2[j], False);
            Wait[j] := 4
        End
      End
    End;

    Inc(Tahti);
    Inc(x, 9);

    If(Tahti Shr 2) = 16 Then
    Begin
      Nuotit[y][1] := i;

      Line12(x, EkaRivi+1, x, EkaRivi+ViivaPax*4-1, Viiva);
      If x<>Endi Then
      Begin
        Endi := x;
        Goto P1
      End;
      Inc(y);
      x := Eka;
      Tahti := 0;
      Inc(EkaRivi, 100);
      If y >= Rows Then
      Begin
        ShowMouse;

        Asm
          mov di, 4123h
          push di
           push di
           call RandInt
          pop di
          mov si, 1234h
					int 8
          sub di, ax
          mov PlayFlag, ax {0=ugh}
        End;
				GetIntVec(8, @OldI08);
        GetIntVec(IRQ+8, @OldI0D);

        If(PlayFlag <> 0)And Not _InitDSP Then PlayFlag := 0;

        If PlayFlag <> 0 Then
        Begin
          BufSize := 512;

          No_EOI := False;
          AllocMem('DMA buffer', oBuf, $1000 + (BufSize+15)Shr 4);
          SmpBuf := Ptr((Seg(oBuf^)+$FFF)And $F000, 0);
          TicCount := (BufSize Div TicLen);
          SampleSize := TicCount * TicLen;
          ReSize(oBuf, Seg(SmpBuf^) - Seg(oBuf^) + (SampleSize+15)Shr 4);
          Mem [Seg(SmpBuf^)-1:0]  :=  Mem[Seg(oBuf^)-1: 0];
          MemW[Seg(SmpBuf^)-1:1]  := MemW[Seg(oBuf^)-1: 1];
          MemW[Seg(SmpBuf^)-1:3]  := (SampleSize+15)Shr 4;
          MemL[Seg(SmpBuf^)-1:5]  := MemL[Seg(oBuf^)-1: 5];
          MemL[Seg(SmpBuf^)-1:9]  := MemL[Seg(oBuf^)-1: 9];
          MemL[Seg(SmpBuf^)-1:12] := MemL[Seg(oBuf^)-1:12];
          MemW[Seg(oBuf^)-1:3] := Seg(SmpBuf^) - Seg(oBuf^)-1;
          MemW[Seg(oBuf^)-1:1] := 0;
          AllocMem('cache buffer', Cache, (SampleSize+15)Shr 4);
          For j := 0 To High(MemBlocks.Dat)Do
            If MemBlocks.Dat[j].Seg = Seg(oBuf^)Then MemBlocks.Dat[j].Seg := Seg(SmpBuf^);

          FillChar(SmpBuf^, SampleSize, 0);
          FillChar(Cache^, SampleSize, 0);

          SetIntVec(IRQ+8, @NewI0D);

          Palanen(SmpBuf);
          Asm mov al, 0D0h; call _WriteDSP End;

          Pitch := Rate;
          Rivi := 0;
          Asm
            mov al, IRQ
            add al, 8
            mov byte ptr cs:[offset @1], al
						db 0CDh; @1:db 0
          End;
					SetIntVec(8, @NewI08)
        End;

        Rivi := 0;
        While Not KeyPressed Do
        Begin
          x := GetMouseX;
          y := GetMouseY;

          If(x < 9*64)
						Then If(y>Row1    )And(y<Row1    +ViivaPax*5)Then Rivi := Round(x*(Nuotit[0][1]-Nuotit[0][0])/(9*64) + Nuotit[0][0])
						Else If(y>Row1+100)And(y<Row1+100+ViivaPax*5)Then Rivi := Round(x*(Nuotit[1][1]-Nuotit[1][0])/(9*64) + Nuotit[1][0])
						Else If(y>Row1+200)And(y<Row1+200+ViivaPax*5)Then Rivi := Round(x*(Nuotit[2][1]-Nuotit[2][0])/(9*64) + Nuotit[2][0])
						Else If(y>Row1+300)And(y<Row1+300+ViivaPax*5)Then Rivi := Round(x*(Nuotit[3][1]-Nuotit[3][0])/(9*64) + Nuotit[3][0])
						{Else Rivi := 0
					Else Rivi := 0};

          With Laulu^[Rivi][3]Do Begin Volume:=0 End;
        End;

        Repeat
          If ReadKey=#27 Then Lopeta := True
        Until Not KeyPressed;

        If PlayFlag <> 0 Then
        Begin
          SetIntVec(IRQ+8, @OldI0D);
					SetIntVec(8, @OldI08);
          _DoneDSP;
          UnAllocMem(Cache);
          UnAllocMem(SmpBuf)
        End;

        HideMouse;
        x := Eka;
        y := 0;
        Clr
      End
    End;

    i := i + Spiid;
    If i >= Riveja Then i := Looppaa
  Until Lopeta
End;
*)

Procedure Show5;
Var
  x, y, w, Pos: Word;
  z: Byte;
Label P2;
Begin
  Show3Init;

  Set256Mode(320, 200);
  CRTLocal.WriteStrProcAddr := SVGA.WriteStr;
  CRTLocal.GotoXYProcAddr := SVGA.GotoXYProc;
  CRTLocal.WhereXFuncAddr := SVGA.WhereXFunc;
  CRTLocal.WhereYFuncAddr := SVGA.WhereYFunc;

  DirectVideo := False;
  FontKork := 8; FontLev := 5;
  TextAttr := 9; TextBack := 0;
  GotoXY(1, 1);
  Write(
    'Heap free: ',MaxAvail,'(',MemAvail,') bytes.'^M^J+
    'Memory free: ',FreeMem,' bytes.');

  Pos := 0;
  Repeat
    While Not KeyPressed Do
    Begin
      GotoXY(1, 3);
      Write('Playing row ',Rivi,' of ',Riveja,'        ');

      GotoXY(1, 4);
      Write(Pos:10,' BufSize:',BufSize);

      If UusPala Then
      Begin
        Pos := 0;
        UusPala := False
      End
      Else If Mem[Seg0040:$6C]<>z Then
      Begin
        z := Mem[Seg0040:$6C];
        Inc(Pos, BufSize Div(Rate Div 800))
      End;

      w := Pos;
      While SmpBuf[w] <= SmpBuf[w+1]Do Inc(w);

      For x := 0 To 319 Do
      Begin
        For y := 0 To 149 Do PSet(x, y+50, 0);
        PSet(x, 50 + DivLong(MulLong(Ord(SmpBuf[w+x*4]),50),GlobalVolume), 5)
      End
    End;
    Case ReadKey Of
      #27: Break;
      '1': PlayChan[0] := Not PlayChan[0];
      '2': PlayChan[1] := Not PlayChan[1];
      '3': PlayChan[2] := Not PlayChan[2];
      '4': PlayChan[3] := Not PlayChan[3];
    End;
  Until False;

  TextMode(CO80);
  CRTLocal.WriteStrProcAddr := WriteStr;

  Show3Done
End;

Var
  OldExit: Procedure;

Procedure SafeExit; Far;
Var I: Boolean;
Begin
  ExitProc := OldExit;
  I := IRQs;
  Show3Done;
  If I And Debugging Then
    WriteLn('NESMusa Warning: Was interrupted, did not'^M^J,
            '':17, 'release int vectors. Released now.')
End;

Begin
  OldExit := ExitProc;
  ExitProc := SafeExit;

  IRQs := False
End.
