{
	This unit does the conversions
}

{ Created in <=2000 - Copyright (C) Joel Yliluoma }

Unit NESMusa5;

Interface

Const
	NoDetails:   Byte    = 0;     { -D  switch adds     }
	NoBrains:    Boolean = False; { -L  switch sets     }
	MustTryMore: Boolean = False; { -O  switch enables  }
	EnableSBx:   Boolean = True;  { -KL switch disables }
	EnableCxx:   Boolean = True;  { -KN switch disables }
	Optimizing:  Boolean = True;  { -1  switch disables }
	SkipVolDet:  Boolean = False; { -KD switch enables  }
	SNDSkip:     Word    = 0;     { -Q# switch changes  }

Var
	TrySxx:  Boolean; {Note that TryMore and not TrySxx}
	TryMore: Boolean; {     is an invalid combination.}
										{These options must be}
										{set to False by default.}
	Optimized: Integer; {Times looped}

Procedure Converter;

Implementation

Uses WinDos, Objects, DosMem, Strings, NesMusa1, NesMusa4;

Var
	FI: TDosStream;
	FO: TBufStream;

Type
  PSample = ^TSample;
  TSample = Record
    Typi  : Byte; {2 = AMel}
    DosName: Array[0..11]Of Char; {AsciiZ file name}
    MemSeg: Word;
    Zero:   Byte;
    Length: LongInt;
		LoopBeg:LongInt;
		LoopEnd:LongInt;
		Volume: Byte; {Volume}
		Filler1:Byte;
		Pack:   Byte;
		Flags:  Byte;
		C2Spd : Word; {8363 = normal..?}
		Filler2: Array[$2..$F]Of Byte;
		Name: Array[0..27]Of Char; {AsciiZ sample name}
		Ident : Array[0..3]Of Char; {SCRI}
	End;

Const
	Note  =0;
	Volume=1;

Type
	TPatRivi = Record Data: Array[0..3,0..1]Of Byte; Skip, Loopi: Byte End;
	TPattern = Array[0..63]Of TPatRivi;
	PPattern = ^TPattern;

Const
	MaxOrd = 256;

Var
	Patterns: Array[0..MaxMemBlock-4]Of PPattern;
	PatRows: Array[0..MaxMemBlock-4]Of Array[0..63]Of Word;
	OptInfo: PChar;                                              {0=Normal
																					1=Cut here, disable SE0 optimization
																					2=Re-enable SE0 optimization}
	Row, PatternCount: Integer;
	RowCounter: Word;
	Skipper: Word;

Var
	ConvName: Array[0..255]Of Char;

Procedure InitS3M;
Begin
	PatternCount := 0;
	Row := -1
End;

Procedure NewPattern;
Var
	Chan: Integer;
	MyPat: PPattern;
Begin
	AllocMem('pattern buffer', MyPat, (SizeOf(TPattern)+15)Shr 4);

	For Row := 0 To 63 Do
	Begin
		For Chan := 0 To 3 Do
		Begin
			MyPat^[Row].Data[Chan][Note  ] := 255;
			MyPat^[Row].Data[Chan][Volume] := 255
		End;
		MyPat^[Row].Loopi := 255;
		MyPat^[Row].Skip := 0
	End;

	Row := 0;
	Patterns[PatternCount] := MyPat;
	Inc(PatternCount)
End;

Procedure SetLine(Channel: Integer; N, V: Byte);
Begin
	If Channel >= 4 Then Exit;
	If Row = -1 Then NewPattern;

	If NoDetails <> 0 Then
		If Channel = 3 Then N := $45;

	If Channel = 3 Then
		Case NoDetails Of
			0: ;
			1: N := $45;
			Else Begin N := 0; V := 0 End
		End;
	If Channel = 2 Then If NoDetails > 2 Then Begin N := 0; V := 0 End;
	If Channel = 0 Then If NoDetails > 3 Then Begin N := 0; V := 0 End;

	If(V <> 0)Or NoBrains Then
		Patterns[PatternCount-1]^[Row].Data[Channel][Note  ] := N;
	Patterns[PatternCount-1]^[Row].Data[Channel][Volume] := V;

	If Not(TrySxx Or TryMore)Then
		PatRows[PatternCount-1][Row] := RowCounter
End;

Const LoopOpt: Byte = 0;
Const LoopOpt2: Byte = 0;
Var MyPat: PPattern;

Procedure SBxOpt;
Var v, bc, bp, bl, Len, Count, Max, a, b: Integer;
Label P3, P4, P5;
Begin
	If(TryMore Or(TrySxx And Not Optimizing))And EnableSBx Then
	Begin
		Max := Row-1;
P3:	bc := 0;
		bl := 0;
		For a := LoopOpt2 To Max-1 Do
		Begin
			For Len := (Max-a)Div 2 Downto 1 Do
			Begin
				Loop;
				If(MyPat^[a].Loopi = 0)Then
				Begin
					b := MyPat^[a+Len].Loopi;
					If(b>0)And(b<255)Then
					Begin
						MyPat^[a    ].Loopi := 255;
						MyPat^[a+Len].Loopi := 255;

						For Count := 1 To 16-b Do
						Begin
							If a+(Len+1)*Count+Len >= Max Then Break;
							If memcmp(@MyPat^[a],
												@MyPat^[a+(Len+1)*Count],
												SizeOf(TPatRivi) * Len
												) <> 0 Then Break
						End;
						Dec(Count);

						MyPat^[a    ].Loopi := 0;
						MyPat^[a+Len].Loopi := b+Count;

						If Count > 0 Then
						Begin
							If Debugging Then
								WriteLn('Added ',Count,' to SB',HC[b],' in pattern ',PatternCount-1,'.');

							bc := Count;
							bl := Len;
							bp := a;
							Goto P4
						End
					End
				End;

				For b := 0 To Len Do
					If MyPat^[a+b].Loopi <> 255 Then Goto P5;

				For Count := 1 To 15 Do
				Begin
					If a+(Len+1)*Count+Len >= Max Then Break;

					If memcmp(@MyPat^[a],
										@MyPat^[a+(Len+1)*Count],
										SizeOf(TPatRivi) * (Len+1)
										) <> 0 Then Break
				End;
				{Loopin jlkeen Count kertoo, miss meni pieleen -
				 eli sit edellinen viel on ok. Siksi Count-1.
				 Mr kertoo toistojen lukumrn. Jos mr on
				 1, komento on SB1 eli ptk soitetaan kahdesti.}
				Dec(Count);
				If Count*(Len+1) > bc*(bl+1)Then
				Begin
					bc := Count;
					bl := Len;
					bp := a;
					Count := 0
				End;
P5:		End
		End;
		If bc > 0 Then
		Begin
			If Debugging Then
				WriteLn('SB',HC[bc],' -optimized ',bc*(bl+1),' lines from pattern ',PatternCount-1,'.');

			{WriteLn('pat=',PatternCount-1,' bp=',bp);}
			b := MyPat^[bp+bl].Skip;
			If b > 0 Then
			Begin
				Dec(MyPat^[bp+bl].Skip);
				b := 1
			End;

P4:		For a := 0 To Max-(bp+bl+1+b)Do
			Begin
				If a+bp+(bl+1)*(bc+1) > 63 Then Break;
				MyPat^[a+bp+bl+1+b] := MyPat^[a+bp+(bl+1)*(bc+1)]
			End;

			v := 0;
			If Count = 0 Then
			Begin
				If b > 0 Then
				Begin
					For v := 0 To 3 Do
					Begin
						MyPat^[bp+bl+1].Data[v][Note  ] := 255;
						MyPat^[bp+bl+1].Data[v][Volume] := 255
					End;
					MyPat^[bp+bl+1].Skip := 0
				End;
				MyPat^[bp     ].Loopi := 0;
				MyPat^[bp+bl+b].Loopi := bc;
				v := b
			End;

			Dec(Max, bc*(bl+1)-v);

			For a := Max+1 To 63 Do
			Begin
				For b := 0 To 3 Do
				Begin
					MyPat^[a].Data[b][Note  ] := 255;
					MyPat^[a].Data[b][Volume] := 255;
				End;
				MyPat^[a].Loopi := 255;
				MyPat^[a].Skip := 0
			End;

			LoopOpt := bp+bl+1+v;
			LoopOpt2 := bp;
			Goto P3
		End;

		Row := Max+1;
	End
End;

Procedure NewLine;
Var
	a, b, v, p,r, p2,r2: Integer;
Label P1;
Begin
	If(PatternCount=0)And(Row=-1)Then Exit;

	If Row = -1 Then NewPattern;
	If Row = -1 Then Exit;

	If TryMore Then
		Case OptInfo[RowCounter]Of
			#1:
			Begin
				If(Row >= 40)And EnableCxx Then
				Begin
					{If Optimized < 5
						Then TrySxx := False
						Else Debug('Optimized too much times. Problem.');}

					If Debugging And DosMemDebug Then
						WriteLn('Patn ',PatternCount,' Row ',Row,' - clipclip');

					SBxOpt;

					Patterns[PatternCount-1]^[Row].Skip :=
					Patterns[PatternCount-1]^[Row].Skip Or $10;

					NewPattern;
					If Row=-1 Then Exit
				End
			End;
			#2: TrySxx := True;
		End;

	If Row = 0 Then
	Begin
		LoopOpt := 0;
		LoopOpt2 := 0
	End;

	If RowCounter = 65519 Then
	Begin
		WriteLn('Internal limit exceeded, not processing over 65520 rows');
		Exit
	End;

	Inc(RowCounter);

	MyPat := Patterns[PatternCount-1];

	For a := 0 To 3 Do
	Begin
		v := MyPat^[Row].Data[a][Volume];
		If v=0 Then MyPat^[Row].Data[a][Note] := 255
	End;

	p := PatternCount-1;
	r := Row-1;
	If r >= LoopOpt Then
	Begin
		If r < 0 Then Begin r := 63; Dec(p)End;
		If p >= 0 Then
		Begin
			For a := 0 To 3 Do
			Begin
				If MyPat^[Row].Data[a][Note] = 255 Then
					MyPat^[Row].Data[a][Note] := Patterns[p]^[r].Data[a][Note];

				If MyPat^[Row].Data[a][Volume] = 255 Then
					MyPat^[Row].Data[a][Volume] := System.Max(0, Patterns[p]^[r].Data[a][Volume]-Sustain)
			End;

			If NoDetails <> 0 Then
			Begin
				p2 := p;
				r2 := r-1;
				If r2<0 Then Begin r2 := 63; Dec(p2)End;
				If(p2 >= 0)
				And(Patterns[p]^[r].Loopi = 255)
				And(Patterns[p]^[r].Skip <= 1)Then
					For a := 0 To 2 Do
					Begin
						If(MyPat^[Row].Data[a][Volume] <> 0)
						And(MyPat^[Row].Data[a][Note] <> 255)Then
						Begin
							b := Patterns[p]^[r].Data[a][Note];
							If(b <> 255)And(MyPat^[Row].Data[a][Note] <> b)
							And(Patterns[p2]^[r2].Data[a][Note] <> 255)Then
							Begin
								MyPat^[Row].Data[a][Note  ] := 255;
								MyPat^[Row].Data[a][Volume] := 255
							End
						End
					End
			End;

			If Sustain > 0 Then
				For a := 0 To 3 Do
				Begin
					v := Patterns[p]^[r].Data[a][Volume];
					If(v<1)Or(v>64)Then Continue;

					If MyPat^[Row].Data[a][Volume] = 0 Then
					Begin
						MyPat^[Row].Data[a][Note  ] := Patterns[p]^[r].Data[a][Note];
						MyPat^[Row].Data[a][Volume] := System.Max(0, v-Sustain)
					End
				End;

			If TrySxx And((Patterns[p]^[r].Skip And 15) < 15)
								And(Patterns[p]^[r].Loopi = 255)Then
			Begin
				For a := 0 To 3 Do
					If((MyPat^[Row].Data[a][Volume] <> Patterns[p]^[r].Data[a][Volume])
					And((MyPat^[Row].Data[a][Note] <> 255)
						Or(MyPat^[Row].Data[a][Volume] <> 255)
						 )
						)
					Or((MyPat^[Row].Data[a][Note] <> Patterns[p]^[r].Data[a][Note])
					And(MyPat^[Row].Data[a][Note] <> 255))Then
						Goto P1;
				Inc(Patterns[p]^[r].Skip);
				Exit;
P1:  	End
		End
	End;

	Inc(Row);
	If Row = 64 Then SBxOpt;
	If Row >= 64 Then Row := -1
End;

Procedure AddLines(Count: Integer);
Begin
	While Count <> 0 Do
	Begin
		If Skipper > 0
			Then Dec(Skipper)
			Else NewLine;
		Dec(Count)
	End
End;

Var
	TooHighs: Array[0..63]Of Record Freq: Word; Count: LongInt End;
Const
	TooHighCount: Integer = 0;

Procedure FlushTooHigh;
Var a: Integer;
Begin
	If TooHighCount = 0 Then Exit;
	If Debugging Then
	Begin
		For a := 0 To TooHighCount-1 Do
		Begin
			{ Bubble Man:
				 7990   (once)
				 46325  (785 times)
				 55930  (464 times)
			}
			Write('Too high frequency, ',TooHighs[a].Freq,' (');
			If TooHighs[a].Count > 1
				Then WriteLn(TooHighs[a].Count,' times).')
				Else WriteLn('once).')
		End;
		WriteLn('Too high frequencies are above octave 7 and action is channel muting.')
	End;

	TooHighCount := 0
End;

(* Generate sound of given frequency (Hz) and volume     *)
(* (0..255) via given channel.                           *)
Procedure Sound(Channel: Byte; Freq: Word; Vol: Byte);
Var Chan, Oct, Note: Integer;
Var NoteNum, LastFreq: Word;
Label P1;
Begin
	{If(PatternCount=0)And(Row=-1)And(Vol=0)Then Exit;}
	If Skipper > 0 Then Exit;

	Vol := Vol Shr 2;

	Oct  := 0;
	Note := 0;
	NoteNum := 58;
	LastFreq := 1;

	If SkipVolDet And(Vol > 0)Then
	Begin
		If(Channel = 2)And(Vol < 25)And(NoDetails <> 0)Then
			If Vol > 3 Then Vol := 6*Round(Vol/6)Else
		Else
			If Vol <= 4 Then Vol := 4
			Else If Vol > 40 Then Vol := 55
			Else If Vol > 10 Then Vol := 16*Round(Vol/16)
			Else Vol := 8*Round(Vol/8)
	End;

	If Vol <> 0 Then
		While LastFreq < Freq Do
		Begin
			{        notenum = 12 * log(freq) / log(2)              }
			{  Kyt tt viel joskus           1.10.1998/Bisqwit  }

			LastFreq := Round(Exp(NoteNum / 17.31234049066756 {(12.0 / Ln(2.0))}) / 1.019922 {finetune});

			{2^(notenum/12)}

			If Note = 11 Then
			Begin
				If Oct = 7 Then
				Begin
					For Chan := 0 To TooHighCount-1 Do
						If Freq = TooHighs[Chan].Freq Then
						Begin
							Inc(TooHighs[Chan].Count);
							Goto P1
						End;

					If TooHighCount > High(TooHighs)Then
						FlushTooHigh;

					If TooHighCount = 0 Then
						Debug('Found one or more too high frequencies...');

					TooHighs[TooHighCount].Freq := Freq;
					TooHighs[TooHighCount].Count := 1;
					Inc(TooHighCount);

P1:				Vol := 0;
					Break
				End;
				Note := 0;
				Inc(Oct)
			End
			Else
				Inc(Note);

			Inc(NoteNum)
		End;

	Chan := Channel;
	If Chan=0 Then Chan := 1;

	If Vol=0 Then
		SetLine(Channel, 0, 0)
	Else If(Note>0)Or(Oct>0)Then
		SetLine(Channel, (Oct Shl 4)Or Note, GammaCalculation(Vol))
End;

Function TestData(Chan, Skipped: Byte; Row: Integer; MyPat: PPattern; prn, prv: Byte): Byte;
Var Data: Byte;
Begin
	Data := Chan;

	If NoBrains Then
		Data := Data Or $60
	Else
	Begin
		If MyPat^[Row].Data[Chan][Note] <> 255 Then
			If(MyPat^[Row].Data[Chan][Note] <> prn)
			Or((MyPat^[Row].Data[Chan][Volume] <> prv)And(prv = 0))
			Or(MyPat^[Row].Loopi < 16)
			Then Data := Data Or $20;

		If MyPat^[Row].Data[Chan][Volume] <> 255 Then
			If((prn <> MyPat^[Row].Data[Chan][Note])
			 And(MyPat^[Row].Data[Chan][Volume] <> 48))
			 Or(prv <> MyPat^[Row].Data[Chan][Volume])
			 Or(MyPat^[Row].Loopi < 16)
			Then Data := Data Or $40
	End;

	If((Chan=2)And((MyPat^[Row].Skip And 15) <> 0))
	Or((Chan=3)And(MyPat^[Row].Skip > 15)And(Row < 63))
	Or((Chan=1)And(MyPat^[Row].Loopi < 16))Then Data := Data Or $80;

	TestData := Data
End;

Function DoneS3M: Boolean;
Const
	Header: Array[0..$3F]Of Char = 'Song generated by NESMusa';
	Nolla: Array[0..63]Of Char = '';
Var
	Len, Flags, InsNum, OrdNum: Word;
	Skipped, WaitLen, Chan, RiviSkip, Instru, Data: Byte;
	Waiting: Array[0..31]Of Byte;
	Channels: Array[0..31]Of Byte;
	Orders: Array[Byte]Of Byte;
	SmpName: Array[0..12]Of Char;
	NewPos, i, l: LongInt;
	LineClear: Boolean;
	MyPat: PPattern;
	b, a: Integer;
	PatMatch, prn,prv,p,r: Integer;
Label P1, P2, P3, P4, P5;
Begin
	DoneS3M := False;

	InsNum := 3{5};
	Flags := 0;

	OrdNum := (PatternCount+1)And $FFE;

	Header[$1C] := #$1A;
	Header[$1D] := #16; {Type = S3M module}

	strcpy(Header+$2C, 'SCRM');

  Header[$30] := #$40; {Global volume}
	Header[$31] :=   #1; {Cmd A}
	Header[$32] := Chr(TicPeriod * 60 Div 24); {Cmd T}
	Header[$33] := #$A8; {Master volume + Stereo}
  Header[$34] :=  #16; {Ultra Click Removal}
	Header[$35] :=   #0; {Dfl pan}

  FillChar(Channels, SizeOf(Channels), 255);
  Channels[0]:=0; Channels[1]:=8;
  Channels[2]:=1; Channels[3]:=9;

  Debug('Creating order list');
	FillChar(Orders, SizeOf(Orders), $FF);
  For a := 0 To PatternCount-1 Do Orders[a] := a;

  If Optimizing Then
	Begin
		WriteLn('Optimizing...');
		PatMatch := 0;
		For a := 1 To PatternCount-1 Do
		Begin
			Loop;
			For b := 0 To a-1 Do
				If Patterns[b] <> Nil Then
					If MemCmp(PChar(Patterns[a]), PChar(Patterns[b]), SizeOf(TPattern))=0 Then
					Begin
						If Not TrySxx Then
						Begin
							If a>0 Then OptInfo[PatRows[a-1][63]] := #1;
													OptInfo[PatRows[a  ][ 0]] := #2;

							If b>0 Then OptInfo[PatRows[b-1][63]] := #1;
													OptInfo[PatRows[b  ][ 0]] := #2
						End;

						If Debugging And DosMemDebug Then
							Write('Patterns ',b,' and ',a,' are identical; ');
						Inc(PatMatch);
						UnAllocMem(Patterns[a]);
						Patterns[a] := Nil;
						Orders[a] := b;

						Break;
					End
		End;

P1: a := 0;
		While a < PatternCount Do
		Begin
			If Patterns[a] = Nil Then
			Begin
				b := PatternCount;
				While Patterns[b] = Nil Do Begin If b=0 Then Break; Dec(b)End;
				PatternCount := b+1;
				If b<a Then Continue;
				If Debugging And DosMemDebug Then
					WriteLn('Moving pattern ',b,' to ',a);
				Patterns[a] := Patterns[b];
				Patterns[b] := Nil;
				For i := 0 To OrdNum-1 Do
					If Orders[i] = b Then
						Orders[i] := a;
				Goto P1
			End;
			Inc(a)
		End;

		If Debugging And (PatMatch <> 0)Then
			WriteLn('Optimized ',PatMatch,' pattern duplicates.')
  End;

	Debug('Comparing to S3M limits...');

	FlushTooHigh;

	If PatternCount > 100 Then
	Begin
		If Not(TrySxx And TryMore)Then
    Begin
      Write('S3M limit encountered, ',PatternCount-100,' pattern');
      Goto P4
    End;
    WriteLn('S3M limit exceeded, truncating to ','100 patterns - ',PatternCount-100,' patterns lost!');
    For a := 100 To PatternCount-1 Do
    Begin
      UnAllocMem(Patterns[a]);
      Patterns[a] := Nil;

P3:   For i := 0 To OrdNum-1 Do
				If Orders[i] = a Then
				Begin
					If(i>0)And(Orders[i-1] = 254)Then
					Begin
						Move(Orders[i+1], Orders[i], 255-i);
						Orders[255] := 255;
						Dec(OrdNum);
						Goto P3
					End;
					Orders[i] := 254
				End
		End;
		PatternCount := 100
	End
	Else If MustTryMore Then
		If Not(TryMore And TrySxx)Then Goto P5;

	If OrdNum > MaxOrd Then
	Begin
		If Optimizing And Not(TrySxx And TryMore)Then
		Begin
			Write('S3M limit encountered, ',OrdNum-MaxOrd,' order');
P4:   Write('s would be lost! ');
P5:		WriteLn('Raising optimization level.');
			If TrySxx Then TryMore := True;
			TrySxx := True;
			For a := 0 To PatternCount-1 Do
				If Patterns[a] <> Nil Then
				Begin
					UnAllocMem(Patterns[a]);
					Patterns[a] := Nil
				End;
			InitS3M;
			Exit
		End;

		WriteLn('S3M limit exceeded, truncating to ',MaxOrd,' orders - ',OrdNum-MaxOrd,' orders lost!');

		OrdNum := MaxOrd;

		For a := 0 To PatternCount-1 Do
			If Patterns[a] <> Nil Then
      Begin
        For i := 0 To OrdNum-1 Do If Orders[i] = a Then Goto P2;
        UnAllocMem(Patterns[a]);
        Patterns[a] := Nil;
P2:   End;
    If Optimizing Then Goto P1
	End;

	FillChar(Orders[OrdNum], 100, $FF);

  PWord(@Header[$20])^ := OrdNum;
  PWord(@Header[$22])^ := InsNum;
  PWord(@Header[$24])^ := PatternCount;
  PWord(@Header[$26])^ := Flags;
  PWord(@Header[$28])^ := S3MVersion;
	PWord(@Header[$2A])^ := 2;       {Unsigned samples}

  Debug('Writing header, channels and orders');
	FO.Seek(0);
	FO.Write(Header, $40);
	FO.Write(Channels, $20);
	FO.Write(Orders, OrdNum);

	NewPos := ($60 + OrdNum + InsNum*2 + PatternCount*2 + 15)Shr 4;

	Debug('Writing samples');
	l := FO.GetPos;
	For a := 0 To InsNum Do
	Begin
		FO.Seek(l);
		FO.Write(NewPos, 2);
		l := FO.GetPos;

		FO.Seek(NewPos Shl 4);

		{The file will be reorganized anyways}
		FO.Write(PChar(@NSMP1)^, 112);
		{So we don't write the correct samples yet here}

		i := FO.GetPos + 15;

		FO.Seek((NewPos Shl 4) + 14);
		Inc(NewPos, 5);
		FO.Write(NewPos, 2); {Memseg}

		NewPos := i Shr 4
	End;

	Debug('Writing patterns');
	For a := 0 To PatternCount-1 Do
	Begin
		Flags := 1;

		NewPos := (FO.GetPos + 15)Shr 4;

		FO.Seek($60 + OrdNum + InsNum*2 + a*2);
		If Patterns[a] = Nil Then
		Begin
			Flags := 0;
			FO.Write(Flags, 2)
		End
		Else
			FO.Write(NewPos, 2);

		FO.Seek((NewPos Shl 4) + 2);

		If Flags = 0 Then Continue;

		RiviSkip := 0;
		WaitLen := 0;
		Skipped := 0;

		MyPat := Patterns[a];
		For Row := 0 To 63 Do
		Begin
			Loop;

			LastChan := 4;

			r := Row-1;
			p := a;
			If r<0 Then Begin r := 63; Dec(p)End;

			For Chan := 0 To 3 Do
			Begin
				Prn := 0;
				Prv := 0;
				If p>=0 Then
				Begin
					Prn := Patterns[p]^[r].Data[Chan][Note];
					Prv := Patterns[p]^[r].Data[Chan][Volume]
        End;
        Data := TestData(Chan, Skipped, Row, MyPat, prn,prv);
        If Data <> Chan Then LastChan := Chan
      End;

      If LastChan < 4 Then
			Begin
        For Chan := 3 DownTo 0 Do
				Begin
          Instru := Chan;
          If Chan=0 Then Instru := 1;

          Prn := 0;
          Prv := 0;
					If p>=0 Then
          Begin
            Prn := Patterns[p]^[r].Data[Chan][Note];
            Prv := Patterns[p]^[r].Data[Chan][Volume]
          End;
					Data := TestData(Chan, Skipped, Row, MyPat, prn,prv);

          If Data <> Chan Then
          Begin
						FO.Write(Waiting, WaitLen);
						WaitLen := 0;

						Waiting[WaitLen] := Data;
						Inc(WaitLen);

						If(Data And $20) <> 0 Then
						Begin
							Waiting[WaitLen] := MyPat^[Row].Data[Chan][Note];
							{
							If Waiting[WaitLen]Shr 4 > 6 Then
              Begin
                Dec(Waiting[WaitLen], $20);
								Inc(Instru, 3)
              End;

              }Inc(WaitLen);
              Waiting[WaitLen] := Instru; Inc(WaitLen)
            End;

            If(Data And $40) <> 0 Then
            Begin
              Waiting[WaitLen] := MyPat^[Row].Data[Chan][Volume];
              Inc(WaitLen)
            End;

						If(Data And $80) <> 0 Then
						Begin
							If(Chan = 1)And(MyPat^[Row].Loopi < 16)Then
							Begin
								Waiting[WaitLen] := Ord('S') - 64;

								Inc(WaitLen);

								Waiting[WaitLen] := $B0+MyPat^[Row].Loopi;

								Inc(WaitLen)
							End
							Else If(Chan = 2)And(MyPat^[Row].Skip And 15 <> 0)Then
							Begin
								Waiting[WaitLen] := Ord('S') - 64;

								Inc(WaitLen);

								Waiting[WaitLen] := $E0+MyPat^[Row].Skip;

								Inc(WaitLen)
							End
							Else If(Chan = 3)And(MyPat^[Row].Skip > 15)Then
							Begin
								Waiting[WaitLen] := Ord('C') - 64;

								Inc(WaitLen);

								Waiting[WaitLen] := 0;

								Inc(WaitLen)
							End
							Else
							Begin
								Waiting[WaitLen] := Ord('O') - 64; Inc(WaitLen);
								Waiting[WaitLen] :=             0; Inc(WaitLen)
							End
						End
					End
        End
			End;

      Waiting[WaitLen] := 0;
			Inc(WaitLen);
			FO.Write(Waiting, WaitLen);
			WaitLen := 0;
			Skipped := 0
		End;

		FO.Write(Waiting, WaitLen);
		FO.Write(Nolla, RiviSkip);

		Len := FO.GetPos - (NewPos Shl 4);
		FO.Seek(NewPos Shl 4);
		FO.Write(Len, 2);
		FO.Seek(Len+FO.GetPos);

		If Debugging And DosMemDebug Then
			Write('Pattern ',a,': ',Len,' bytes written; ');

		UnAllocMem(MyPat)
	End;

	DoneS3M := True
End;

Procedure SNDConv;
Var
	Buf: Array[0..15]Of Char;
	I, BRead: Word;
	p, q: PChar;
	s, fn: String;
	J,K: Byte;
	a: Integer;
Label
	ReConvert;
Begin
	TrySxx := False;
	TryMore := False;

	If Debugging
		Then Write('Opening s')
		Else Write('S');
	WriteLn('ource file: ',Name);

	FI.Init(Name, stOpenRead + stDenyWrite);
	If FI.Status <> stOk Then
		Error('*** Trouble opening.');

	Debug('Reading header');

	FI.Read(Buf, 16);

	If strncmp(PChar(@Buf), 'SND'^Z, 4) <> 0 Then
	Begin
		FI.Done;
		Error('*** Not an SND file!')
	End;

	If AutoTicker Then
	Begin
		TicPeriod := Ord(Buf[6]);
		If Debugging Then WriteLn('Tick rate ',TicPeriod,' Hz')
	End;

	Debug('Opening output file');

	InitS3M;

	p := strrscan(Name, '\');
	If p = Nil Then p := Name Else Inc(p);

	q := strrscan(Name, '.');
	If q = Nil Then
		s := strpas(strupper(p))
	Else
	Begin
		s[0] := Chr(q-p);
		For a := 1 To Ord(s[0])Do s[a] := UpCase(p[a-1])
	End;

	fn := s + '.S3M'#0;

	FillWord(Patterns, SizeOf(Patterns)Shr 1, 0);

	If Debugging Then WriteLn('Output file is ', PChar(@fn)+1);

	FO.Init(PChar(@fn)+1, stCreate + stDenyAll, 16384);

	IF FO.Status <> stOk Then
	Begin
		FI.Done;
		FO.Done;
		Error('*** Can''t open output file.')
	End;

	If Debugging
		Then WriteLn('Reading...')
		Else WriteLn('Converting to ', PChar(@fn)+1);

	AllocMem('optimization information', OptInfo, $1000);
	FillWord(OptInfo^, 32760, 0);

	Optimized := 0;

ReConvert:
	RowCounter := 0;
	SetLine(0, 0, 0);
	SetLine(1, 0, 0);
	SetLine(2, 0, 0);
	SetLine(3, 0, 0);
	Skipper := SNDSkip;
	If(Skipper > 0)And Debugging Then WriteLn('Skipping ',Skipper,' ticks...');
	Repeat
		Loop;
		FI.Read(J, 1);
		If FI.Status <> stOk Then Break;

		Case J Of
			$FF: AddLines(1);
			$FD:
			Begin
				FI.Read(K, 1);
				AddLines(K)
			End;
			$FE:
			Begin
				FI.Read(J, 1); {Channel}
				FI.Read(K, 1); {Set sound type}
			End;
			Else
				FI.Read(I, 2); {Freq}
				FI.Read(K, 1); {Volume}
				Sound(J, I, K)
		End;
		If PatternCount >= High(Patterns)Then
		Begin
			WriteLn(
				'Too much patterns -- out of memory handles.'^M^J+
				'STOPPING READING AT ',PatternCount,' PATTERNS.');
			Break
		End
	Until False;

	FI.Done;

	If Debugging Then WriteLn(PatternCount,' patterns read.');
	Debug('Flushing.');
	If Not DoneS3M Then
	Begin
		FI.Init(Name, stOpenRead + stDenyWrite);
		FI.Seek(16);
		Inc(Optimized);
		Goto ReConvert
	End;

	UnAllocMem(OptInfo);

	FO.Done;

	strcpy(ConvName, PChar(@fn)+1)
End;

Var
	InstPtr: Array[0..99]Of Word;
	Sample: TSample;

Procedure OptimizeS3MPattern(p: PChar);
Begin
	{TODO}
End;

Const
	ModPeriod: Array[-1..6, 0..11]Of Word =
 ((1712,1616,1525,1440,1357,1281,1209,1141,1077,1017,961,907), {oct1}
	( 856, 808, 762, 720, 678, 640, 604, 570, 538, 508,480,453), {oct3}
	( 428, 404, 381, 360, 339, 320, 302, 285, 269, 254,240,226), {oct4}
	( 214, 202, 190, 180, 170, 160, 151, 143, 135, 127,120,113), {oct5}
	( 107, 101,  95,  90,  85,  80,  76,  71,  67,  64, 60, 57), {oct6}
	(  54,  50,  47,  45,  42,  40,  37,  35,  32,  31, 30, 28), {oct7}
	(  27,  25,  24,  22,  21,  20,  19,  18,  17,  16, 15, 14), {oct8}
	(  13,  13,  12,  11,  11,  10,  10,   9,   9,   8,  7,  7));{oct9}

	ModCmd: Array[0..15]Of Char = 'JFEGHKLRxODBxCSA';
																{0123456789ABCDEF}

Function FindModNote(w: Word): Byte;
Var c, a, b: ShortInt;
Begin
	FindModNote := 255;

  If w=0 Then Exit;

	For c := 0 To 3 Do
		For a := -1 To 6 Do
			For b := 0 To 11 Do
				If Abs(Integer(ModPeriod[a, b]) - Integer(w)) = c Then
				Begin
					FindModNote := b + ((a+1)Shl 4);
					Exit
				End;

	WriteLn('ERROR: Not even near match for period ',w)
End;

Procedure Converter;
Var
	MOD_EmptySamp: Array[0..31]Of Boolean;
	OutName: String[12];
	l4, l3, l2, l: LongInt;
	Piped, IsNES, ModForm: Boolean;
	MOD_WasEmpty: Boolean;
	MOD_SmpPos: LongInt;
	a, b, c: Integer;
	b1,b2,b3,b4: Byte;
	p, q, s: PChar;
	Sz, Sz2: Word;
	Byt: Byte;
Label
	P1, P2, P3, P4;
Begin
	TrySxx := False;
	TryMore := False;

	strcpy(ConvName, Name);

	If Debugging Then WriteLn('Detecting type of "',ConvName,'"...');

	Piped := False;

P4:
	FI.Init(ConvName, stOpenRead + stDenyWrite);
	If FI.Status <> stOk Then
	Begin
		FI.Done;
		Error('*** Trouble opening.')
	End;

	l4 := FI.GetSize;

	FI.Seek(0);
	FI.Read(Hdr, SizeOf(Hdr));

	If strncmp(PChar(@Hdr), 'SND'^Z, 4) = 0 Then
	Begin
		Debug('SND file. Performing SND -> S3M conversion.');
		UnAllocMem(p);
		FI.Done;
		SNDConv;
		Debug('Transferring the result through the conversion pipeline.');
		Piped := True;
		Goto P4
	End;

	AllocMem('pattern buffer', p, 16384);

	Debug('Writing to a temporary file '+CompressorTemp);

	OutName := CompressorTemp + #0;
	FO.Init(PChar(@OutName)+1, stOpen+stFindCreate+stDenyWrite, 16384);

	If strncmp(Hdr.Ident, 'SCRM', 4) <> 0 Then
	Begin
		IsNES := False;

		Move(Hdr.Name, p^, 20);
		FillChar(Hdr, SizeOf(Hdr), 0);

		Debug('Not a S3M file. Performing MOD -> S3M conversion.');
		strcpy(Hdr.Name, p);

		strcpy(Hdr.Ident, 'SCRM');

		Hdr.CtrlZ    := #$1A;
		Hdr.FileType := 16;
		Hdr.MVol     := $30;
		Hdr.GVol     := $40;
		Hdr.InSpeed  := $06;
		Hdr.InTempo  := $7D;
		Hdr.UC       := 16;
		Hdr.DP       := 0;
		Hdr.OrdNum   := 0;
		Hdr.InsNum   := 31;
		Hdr.Flags    := 0;
		Hdr.Version  := S3MVersion;
		Hdr.SmpForm  := 2;

		For a := 0 To 31 Do Hdr.Channels[a] := (a Shr 1) + ((a And 1)Shl 3);
		FI.Seek(950);
		FI.Read(Hdr.OrdNum, 1);
		FI.Seek(952);
		FI.Read(Orders, Hdr.OrdNum);

		b := 0;
		For a := 0 To Hdr.OrdNum - 1 Do
			If Orders[a]+1 > b Then
				b := Orders[a]+1;

		If Odd(Hdr.OrdNum)Then Orders[Hdr.OrdNum] := 255;
		Hdr.OrdNum := (Hdr.OrdNum + 1)And $FFE;

		For a := 0 To Hdr.Insnum-1 Do
			InstPtr[a] := 20 + a*30;

		Hdr.PatNum := b;

		For a := 0 To b - 1 Do
			PatnPtr[a] := 1084 + Word(a)*1024;

		ModForm := True;

		MOD_SmpPos := 1084 + 1024*Hdr.PatNum {Tm tytyy laskea ennen kuin
																					optimointi tiputtaa patterneja
																					pois}
	End
	Else
	Begin
		Debug('S3M file. Reorganizing it.');
		IsNES := True;
		FI.Read(Orders,  Hdr.OrdNum);
		FI.Read(InstPtr, Hdr.InsNum*2);
		FI.Read(PatnPtr, Hdr.PatNum*2);
		ModForm := False
	End;

	If Optimizing Then
	Begin
		Debug('Removing unused patterns');
P1: For a := 0 To Hdr.PatNum-1 Do
		Begin
			For b := 0 To Hdr.OrdNum-1 Do
				If Orders[b] = a Then
				Begin
					Loop;
					b := -1;
					Break
				End;

			If b >= 0 Then
			Begin
				If Debugging Then WriteLn('(Pattern ',a,')');
				PatnPtr[a] := PatnPtr[Hdr.PatNum-1];
				Dec(Hdr.PatNum);
				For b := 0 To Hdr.OrdNum-1 Do
					If Orders[b] = Hdr.PatNum Then
						Orders[b] := a;
				Goto P1
			End
		End;

		Debug('Optimizing orders');
P2: Orders[Hdr.OrdNum] := 255;
		For a := 0 To Hdr.OrdNum-1 Do
		Begin
			If Orders[a] = 255 Then
			Begin
				Hdr.OrdNum := (a+2)And $FE;
				Break
			End;
			If Orders[a] = 254 Then
				If Orders[a+1] = 254 Then
				Begin
					For b := a To Hdr.OrdNum-1 Do
						Orders[b] := Orders[b+1];
					Dec(Hdr.OrdNum);
					Goto P2
				End
		End
	End;

	If ModForm And Optimizing Then
	Begin
		Debug('Optimizing instrument list');
		For a := Hdr.InsNum-1 DownTo 0 Do
		Begin
			FI.Seek(InstPtr[a]);
			FI.Read(Sample.Name, 22);
			FI.Read(Sample.Length, 2);
			If(Sample.Name[0] <> #0)Or(Sample.Length <> 0)Then Break;
			Hdr.InsNum := a
		End
	End;

	Debug('Putting header there.');

	FO.Write(Hdr,    SizeOf(Hdr));
	FO.Write(Orders, Hdr.OrdNum);

	FO.Seek(SizeOf(Hdr) + Hdr.OrdNum + Hdr.PatNum*2 + Hdr.InsNum*2);

	FillChar(Sample, SizeOf(Sample), 0);
	Sample.C2Spd := 8363;
	PLongInt(@Sample.Ident)^ := $49524353; {SCRI}

	Debug('Writing instruments');
	If IsNES Then
		For a := 0 To Hdr.InsNum-1 Do
		Begin
			l := (FO.GetPos + 15)And $FFFFFFF0;
			FO.Seek(l);
			InstPtr[a] := l Shr 4;

			Case a Of
				0:   FO.Write(PChar(@NSMP1)^, SizeOf(Sample));
				1:   FO.Write(PChar(@NSMP2)^, SizeOf(Sample));
				2:   FO.Write(PChar(@NSMP3)^, SizeOf(Sample));
				Else FO.Write(Sample,         SizeOf(Sample));
			End
		End
	Else
	Begin
		For a := 0 To Hdr.InsNum-1 Do
		Begin
			l := (FO.GetPos + 15)And $FFFFFFF0;
			FO.Seek(l);
			If ModForm Then
			Begin
				FillChar(Sample, SizeOf(Sample), 0);

				FI.Seek(InstPtr[a]);
				strcpy(Sample.DosName, '');
				FI.Read(Sample.Name, 22);
				FillChar(Sample.Name[22], 6, 0);
				FI.Read(Sample.Length, 2);

				b := 0;
				FI.Read(b, 1);
				FI.Read(Sample.Volume, 1);
				FI.Read(Sample.LoopBeg, 2);
				FI.Read(Sample.LoopEnd, 2);

				Sample.Length := Swap(Sample.Length);
				Sample.Length := Sample.Length Shl 1;

				Sample.LoopBeg := Swap(Sample.LoopBeg);
				Sample.LoopBeg := Sample.LoopBeg Shl 1;

				Sample.LoopEnd := Swap(Sample.LoopEnd);
				Sample.LoopEnd := Sample.LoopEnd Shl 1;

				If Sample.LoopEnd > 2 Then Sample.Flags := 1;

				MOD_EmptySamp[a] := Sample.Length = 0;

				If Sample.Length = 0 Then
					FillChar(Sample, SizeOf(Sample), 0);

				Sample.Typi := 1;
				Sample.C2SPD := Word(8363 + ShortInt(b*$10)Div 16)Shl 2;
				PLongInt(@Sample.Ident)^ := $49524353; {SCRI}

				Inc(Sample.LoopEnd, Sample.LoopBeg)
			End
			Else
			Begin
				FI.Seek(InstPtr[a]*16);
				FI.Read(Sample, SizeOf(Sample))
			End;

			InstPtr[a] := l Shr 4;
			FO.Write(Sample, SizeOf(Sample))
		End
	End;

	Debug('Writing patterns');
	For a := 0 To Hdr.PatNum-1 Do
		If PatnPtr[a] <> 0 Then
		Begin
			If ModForm Then
			Begin
				FI.Seek(PatnPtr[a]);

				l := (FO.GetPos + 15)And $FFFFFFF0;

				FO.Seek(l);
				PatnPtr[a] := l Shr 4;

				q := p+2;

				For b := 0 To 63 Do
				Begin
					For c := 0 To 3 Do
					Begin
						FI.Read(b1, 1);
						FI.Read(b2, 1);
						FI.Read(b3, 1);
						FI.Read(b4, 1);

						s := q;
						Inc(q);

						Byt := c;

						MOD_WasEmpty := False;
						If(b1 + (b3 Shr 4)) <> 0 Then
						Begin
							Sz := ((b1 And 15)Shl 8) + b2;
							If(Sz>0)And(Sz<7)Then
							Begin
								Inc(Byt, $20);
								q^ := #255;
								Goto P3
							End;

														q^ := Chr(FindModNote(Sz));
							If q^ <> #255 Then
							Begin
								Inc(Byt, $20);
P3:                         Sz := (b1 And $F0) + (b3 Shr 4);
								If((Sz=0)Or(MOD_EmptySamp[Sz-1]))And Optimizing Then
								Begin
									q^ := #254;
									MOD_WasEmpty := True;
									Sz := 0
								End;
								Inc(q); q^ := Chr(Sz);
								Inc(q)
							End
            End;

            If MOD_WasEmpty Then
						Begin
              Inc(Byt, $40);
              q^ := #0;
              Inc(q)
						End;

            If(b4 <> 0)Or((b3 And 15) <> 0)Then
							If(b3 And 15) = 12 Then
							Begin
								If Not MOD_WasEmpty Then
								Begin
                  Inc(Byt, $40);
									q^ := Chr(b4);
                  Inc(q)
                End
              End
							Else
							Begin
                Inc(Byt, $80);
                q^ := Chr(Ord(ModCmd[b3 And 15])-64); Inc(q);
                q^ := Chr(b4);                        Inc(q)
              End;

            If Byt <> c
              Then s^ := Chr(Byt)
              Else q := s
          End;
          q^ := #0;
					Inc(q)
        End;

        PWord(p)^ := q - p;
      End
      Else
      Begin
				FI.Seek(PatnPtr[a] * 16);

				l := (FO.GetPos + 15)And $FFFFFFF0;

				FO.Seek(l);
        PatnPtr[a] := l Shr 4;

				FI.Read(p[0], 2);
				FI.Read(p[2], PWord(p)^);

				If Optimizing Then OptimizeS3MPattern(p);
      End;
			FO.Write(p^, PWord(p)^)
    End;

  Debug('Writing samples');

	If ModForm Then l3 := MOD_SmpPos;

	For a := 0 To Hdr.InsNum-1 Do
	Begin
		l := (FO.GetPos + 15)And $FFFFFFF0;

		FO.Seek((InstPtr[a]Shl 4) + (Ofs(Sample.MemSeg) - Ofs(Sample)));

		l2 := l Shr 4;
		FO.Write(PChar(@l2)[2], 1); {Memseg}
		FO.Write(PChar(@l2)[0], 2); {Memseg}

		FO.Seek(InstPtr[a]Shl 4);
		FO.Read(Sample, SizeOf(Sample)); {Reading the size from output file}
		Sz := Sample.Length; {Size}

		FO.Seek(l);

		If IsNES Then
		Begin
			FO.Seek(l);

			Case a Of
				0:   FO.Write(PChar(@NSMP1 )[SizeOf(Sample)], Sz);
				1:   FO.Write(PChar(@NSMP2 )[SizeOf(Sample)], Sz);
				2:   FO.Write(PChar(@NSMP3 )[SizeOf(Sample)], Sz);
				Else FO.Write(PChar(@Sample)[SizeOf(Sample)], Sz)
			End
		End
		Else If ModForm Then
		Begin
			FI.Seek(l3);
			FI.Read(p^, Sz);
			Inc(p, Sz);
			Inc(l3, Sz);
			If Debugging Then Write('Smp #',a+1:2,':',Sz:6,'':6);
			Sz2 := Sz;
			While Sz2 > 0 Do
			Begin
				Dec(p);
				Dec(Sz2);
				p^ := Chr(Ord(p^)Xor $80);
			End;
			FO.Write(p^, Sz)
		End
		Else
			WriteLn('ERROR: NON-NES -S3M''S NOT IMPLEMENTED (YET?)')
	End;
	If Debugging And((Hdr.InsNum And 3) <> 0)And ModForm Then WriteLn;

	Debug('Writing the rest of headers.');

	FO.Seek(SizeOf(Hdr) + Hdr.OrdNum);{Return to the point where}
	FO.Write(InstPtr, Hdr.InsNum*2);  {we should have written the}
	FO.Write(PatnPtr, Hdr.PatNum*2);  {pattern- and sample pointers}

	If Not Piped Then
	Begin
		Dec(l4, FO.GetSize);
		Write('Got ');

		If l4 = 0
			Then Write('no ')
			Else Write(Abs(l4),' bytes ');

		If l4 < 0
			Then Write('loss')
			Else Write('gain');
		WriteLn(' into file size.')
	End;

	Debug('Closing files...');
	FI.Done;
	FO.Done;

	Debug('Erasing original, renaming temporary file onto it');

	LFN_Erase(ConvName);
	LFN_Rename(PChar(@OutName)+1, ConvName);

	UnAllocMem(p);

	If Piped Then
		WriteLn(
		 'Done. Notice: Vibratoes, fine slides and other'^M^J+
		 '      tiny changes in sound frequencies are lost due'^M^J+
		 '      to the fact that one octave contains only 12 notes.'^J)
	Else
		WriteLn('Done ', ConvName)
End;

End.
